Properties Methods Events Config Options Direct Link

    Observable
      NativeObservable
        NativeWindow

# Class Ext.air.NativeWindow

Package: | Ext.air
Defined In: | NativeWindow.js
Class: | NativeWindow
Extends: | NativeObservable

Wraps the AIR NativeWindow class to give an Ext friendly API.
This class also adds automatic state management (position and size) for the window (by id) and it can be used for easily creating "minimize to system tray" for the main window in your application.
Note: Many of the config options for this class can only be applied to NEW windows. Passing in an existing instance of a window along with those config options will have no effect.

## Config Options

Config Options | Defined By
--- | ---
| chrome : String The native window chrome (defaults to 'standard', can also be 'none'). | NativeWindow
| height : Number | NativeWindow
| instance : air.NativeWindow The native window instance to wrap. If undefined, a new window will be created. | NativeWindow
| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable
| maximizable : Boolean | NativeWindow
| minimizable : Boolean | NativeWindow
| minimizeToTray : Boolean True to enable minimizing to the system tray. Note: this should only be applied to the primary window in your applica... True to enable minimizing to the system tray. Note: this should only be applied to the primary window in your application. A trayIcon is required. | NativeWindow
| resizable : Boolean | NativeWindow
| transparent : Boolean | NativeWindow
| trayIcon : String The icon to display when minimized in the system tray | NativeWindow
| trayMenu : NativeMenu Menu to display when the tray icon is right clicked | NativeWindow
| trayTip : String Tooltip for the tray icon | NativeWindow
| type : String The native window type - normal, utility or lightweight. (defaults to normal) | NativeWindow
| width : Number | NativeWindow

## Public Properties

Property | Defined By
--- | ---
| id : String | NativeWindow

## Public Methods

Method | Defined By
--- | ---

NativeWindow( `Object config` )
Parameters:

- `config` : Object

Returns:

- ``

NativeWindow

NativeWindow.getRootHtmlWindow() : Window
<static> Returns the javascript "window" object of the first opened window in your application
<static> Returns the javascript "window" object of the first opened window in your application
Parameters:

- None.

Returns:

- `Window`

NativeWindow

NativeWindow.getRootWindow() : air.NativeWindow
<static> Returns the first opened window in your application
<static> Returns the first opened window in your application
Parameters:

- None.

Returns:

- `air.NativeWindow`

NativeWindow

activate() : void
Shows and activates the window
Shows and activates the window
Parameters:

- None.

Returns:

- `void`

NativeWindow

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer : Number

    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

close() : void
Closes the window
Closes the window
Parameters:

- None.

Returns:

- `void`

NativeWindow

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

getCenterXY() : x:
Returns the x/y coordinates for centering the windw on the screen
Returns the x/y coordinates for centering the windw on the screen
Parameters:

- None.

Returns:

- `x:`
  Number, y: Number}

NativeWindow

getNative() : air.NativeWindow
Returns the air.NativeWindow instance
Returns the air.NativeWindow instance
Parameters:

- None.

Returns:

- `air.NativeWindow`

NativeWindow

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hide() : void
Hides the window
Hides the window
Parameters:

- None.

Returns:

- `void`

NativeWindow

isMaximized() : Boolean
Returns true if this window is maximized
Returns true if this window is maximized
Parameters:

- None.

Returns:

- `Boolean`

NativeWindow

isMinimized() : Boolean
Returns true if this window is minimized
Returns true if this window is minimized
Parameters:

- None.

Returns:

- `Boolean`

NativeWindow

moveTo( `Number x`, `Number y` ) : void
Moves the window to the passed xy and y coordinates
Moves the window to the passed xy and y coordinates
Parameters:

- `x` : Number
- `y` : Number

Returns:

- `void`

NativeWindow

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

resize( `Number width`, `Number height` ) : void
Parameters:

- `width` : Number
- `height` : Number

Returns:

- `void`

NativeWindow

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

show() : void
Shows the window
Shows the window
Parameters:

- None.

Returns:

- `void`

NativeWindow

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

## Public Events

Event | Defined By
--- | ---

close : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

closing : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

displayStateChange : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

displayStateChanging : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

move : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

moving : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

resize : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow

resizing : ( `Object e` )
Listeners will be called with the following arguments:

- `e` : Object
  The air event object

NativeWindow